/*
 * liste.c : Liste dinamiche di interi
 */

// Definizione dei tipi

typedef struct elem { 
  int key;
  struct elem *next; 
} elemen_t;

typedef elemen_t* lista_t;

// Funzioni

int is_empty(lista_t lista) {
  return(lista == NULL);
}

int length(lista_t lista) {
  int n = 0;
  while(lista != NULL) {
    n++;
    lista = lista->next;
  }
  return n;
}

lista_t insert(lista_t lista, int key) {
  elemen_t *paux;
  paux = (elemen_t *)malloc(sizeof(elemen_t));
  paux->key = key;
  paux->next = lista;
  return paux;
}

int head(lista_t lista) {
  if(lista != NULL) {
    return lista->key;
  }
  return 0;
}

lista_t delete(lista_t lista) {
  lista_t ret;
  if(lista != NULL) {
    ret = lista->next;
    free(lista);
    return ret;
  }
  return NULL;
}
